//
//  KKLocationManager.swift
//  JGTProject
//
//  Created by ifly on 2017/7/18.
//  Copyright © 2017年 szy. All rights reserved.
//


//#warning plist文件中添加
/*
 * NSLocationAlwaysUsageDescription String 应用程序始终使用定位服务
 * NSLocationWhenInUseUsageDescription String 使用应用程序期间，可以使用定位服务
 */

import UIKit
import MapKit
import CoreLocation


typealias KKLocationBlock = (_ location: CLLocation, _ placemark:CLPlacemark,_ LocationManager: CLLocationManager)->Void

class KKLocationManager: NSObject ,CLLocationManagerDelegate,MKMapViewDelegate{
    
    private let  kkLocationManager = CLLocationManager()
    
    private var kkLocationBlock:KKLocationBlock!
    private var isAllLocation: Bool?

    var distance:Double? // 定位精度
    
    internal static let sharInstance = KKLocationManager()

    
        private func startLocation() {
        
        if CLLocationManager.locationServicesEnabled() {
            
            self.kkLocationManager.delegate = self
            
            if #available(iOS 8.0, *) {
                
                if (self.distance != nil) {
                    self.kkLocationManager.distanceFilter = self.distance!
                }else{
                    self.kkLocationManager.distanceFilter = kCLDistanceFilterNone
                }
                
                self.kkLocationManager.requestWhenInUseAuthorization()
                self.kkLocationManager.desiredAccuracy = kCLLocationAccuracyKilometer
            }
            
            self.kkLocationManager.startUpdatingLocation()
         
        }
    }
    
//    func getLoctionManager(_ succeseBlock:(_ location: CLLocation, _ placemark:CLPlacemark,  _ error:NSError)->Void) -> Void {
//    }
    
    class func getLoction(_ isAlways:Bool,LoctionBlock: @escaping KKLocationBlock){
        
        
        self.sharInstance.isAllLocation = isAlways

        self.sharInstance.startLocation()
        
        self.sharInstance.kkLocationBlock = LoctionBlock
        
    }
    
    func locationManager(_ manager: CLLocationManager, didChangeAuthorization status: CLAuthorizationStatus) {
        
        if status == CLAuthorizationStatus.notDetermined || status == CLAuthorizationStatus.restricted || status == CLAuthorizationStatus.denied {
 
            if #available(iOS 8.0, *) {
                
                if self.isAllLocation == true {
                    
                    if #available(iOS 9.0, *) {
                        manager.allowsBackgroundLocationUpdates = true
                    }

                    if self.kkLocationManager.responds(to:#selector(CLLocationManager.requestWhenInUseAuthorization)) {
                        self.kkLocationManager.requestWhenInUseAuthorization()
                    }
                    
                }else{
                    
                    if self.kkLocationManager.responds(to: #selector(CLLocationManager.requestAlwaysAuthorization)) {
                        self.kkLocationManager.requestAlwaysAuthorization()
                    }
                }

            }
            
        }
        
        manager.startUpdatingLocation()
    }
    
    func locationManager(_ manager: CLLocationManager, didUpdateLocations locations: [CLLocation]) {
        
        let newLocation:CLLocation = locations.first!
        let geocoder = CLGeocoder()
        geocoder.reverseGeocodeLocation(newLocation) { (placemarkBlock, error) in
            
            if (error != nil){
                manager.stopUpdatingLocation()
            }else{
                let  placemark = placemarkBlock?.first
                self.kkLocationBlock(newLocation,placemark!,manager)
                                
            }
     
        }
        
        if !self.isAllLocation! {
            self.kkLocationManager.stopUpdatingLocation()
        }
    }
    
    func locationManager(_ manager: CLLocationManager, didFailWithError error: Error) {
        self.kkLocationManager.stopUpdatingLocation()
    }
    
    func locationManager(_ manager: CLLocationManager, didFinishDeferredUpdatesWithError error: Error?) {
        self.kkLocationManager.stopUpdatingLocation()
    }
    
    
    
}
